/*
 * Copyright 2008,2009 WSO2, Inc. http://www.wso2.org.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.wso2.mercury.client;

import org.apache.axis2.client.ServiceClient;
import org.apache.axis2.Constants;
import org.apache.axis2.AxisFault;
import org.wso2.mercury.util.MercuryConstants;
import org.wso2.mercury.util.MercuryClientConstants;

/**
 * provides some mercury specific client functionalities
 */
public class MercuryClient {

    private ServiceClient serviceClient;

    public MercuryClient(ServiceClient serviceClient) {
        this.serviceClient = serviceClient;
    }

    public void terminateSequence() throws AxisFault {
        terminateSequence(MercuryConstants.DEFAULT_INTERNAL_KEY);
    }

    public void terminateSequence(String key) throws AxisFault {
        serviceClient.getOptions().setProperty(MercuryClientConstants.TERMINATE_MESSAGE, Constants.VALUE_TRUE);
        serviceClient.getOptions().setProperty(MercuryClientConstants.INTERNAL_KEY, key);
        serviceClient.fireAndForget(null);
    }

}
